/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.modules.guosen.useragenter.controller;

import cn.hutool.core.lang.Assert;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.google.common.primitives.ImmutableLongArray;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import lombok.AllArgsConstructor;
import javax.validation.Valid;

import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.Func;
import org.springblade.modules.guosen.agenter.entity.Agenter;
import org.springblade.modules.guosen.agenter.service.IAgenterService;
import org.springblade.modules.guosen.loginUser.entity.LoginUser;
import org.springblade.modules.guosen.loginUser.service.ILoginUserService;
import org.springblade.modules.guosen.useragenter.dto.UserAgenterDTO;
import org.springframework.web.bind.annotation.*;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springblade.modules.guosen.useragenter.entity.UserAgenter;
import org.springblade.modules.guosen.useragenter.vo.UserAgenterVO;
import org.springblade.modules.guosen.useragenter.wrapper.UserAgenterWrapper;
import org.springblade.modules.guosen.useragenter.service.IUserAgenterService;
import org.springblade.core.boot.ctrl.BladeController;

/**
 *  控制器
 *
 * @author BladeX
 * @since 2021-06-25
 */
@RestController
@AllArgsConstructor
@RequestMapping("cyzh-guosen/useragenter")
@Api(value = "", tags = "接口")
public class UserAgenterController extends BladeController {

	private final IUserAgenterService userAgenterService;
	private final IAgenterService agenterService;
	private final ILoginUserService loginUserService;


	/**
	 * 详情
	 */
	@GetMapping("/detail")
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "详情", notes = "传入userAgenter")
	public R<UserAgenterVO> detail(UserAgenter userAgenter) {
		UserAgenter detail = userAgenterService.getOne(Condition.getQueryWrapper(userAgenter));
		return R.data(UserAgenterWrapper.build().entityVO(detail));
	}

	/**
	 * 分页
	 */
	@GetMapping("/list")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "分页", notes = "传入userAgenter")
	public R<IPage<UserAgenterVO>> list(UserAgenter userAgenter, Query query) {
		IPage<UserAgenter> pages = userAgenterService.page(Condition.getPage(query), Condition.getQueryWrapper(userAgenter));
		return R.data(UserAgenterWrapper.build().pageVO(pages));
	}


	/**
	 * 自定义分页
	 */
	@GetMapping("/page")
	@ApiOperationSupport(order = 3)
	@ApiOperation(value = "分页", notes = "传入userAgenter")
	public R<IPage<UserAgenterVO>> page(UserAgenterVO userAgenter, Query query) {
		IPage<UserAgenterVO> pages = userAgenterService.selectUserAgenterPage(Condition.getPage(query), userAgenter);
		return R.data(pages);
	}

	/**
	 * 新增
	 */
	@PostMapping("/save")
	@ApiOperationSupport(order = 4)
	@ApiOperation(value = "新增", notes = "传入userAgenter")
	public R save(@Valid @RequestBody UserAgenter userAgenter) {
		return R.status(userAgenterService.save(userAgenter));
	}

	/**
	 * 修改
	 */
	@PostMapping("/update")
	@ApiOperationSupport(order = 5)
	@ApiOperation(value = "修改", notes = "传入userAgenter")
	public R update(@Valid @RequestBody UserAgenter userAgenter) {
		return R.status(userAgenterService.updateById(userAgenter));
	}

	/**
	 * 新增或修改
	 */
	@PostMapping("/submit")
	@ApiOperationSupport(order = 6)
	@ApiOperation(value = "新增或修改", notes = "传入userAgenter")
	public R submit(@Valid @RequestBody UserAgenterDTO userAgenterDTO) {
		Assert.notNull(userAgenterDTO.getInvitedOpenId(),"被邀请用户的openId不能为空");
		Assert.notNull(userAgenterDTO.getInvitorUserId(),"邀请用户的代理人用户id不能为空");
		LoginUser loginUser = loginUserService.getBaseMapper().selectOne(new QueryWrapper<>(new LoginUser()).lambda()
			.eq(LoginUser::getOpenid, userAgenterDTO.getInvitedOpenId()));
		Assert.notNull(loginUser,"openId找不到对应的用户，请先新增新用户");
		//1-判断被邀请人是否已经有代理
		UserAgenter isExist = this.userAgenterService.getBaseMapper().selectOne(new QueryWrapper<>(new UserAgenter()).lambda()
			.eq(UserAgenter::getUserId, loginUser.getId()));
		if(isExist == null){//该新用户没有代理
			//2-判断邀请人是否为代理商
			Agenter agenter = agenterService.getBaseMapper().selectOne(new QueryWrapper<>(new Agenter()).lambda()
				.eq(Agenter::getUserId, userAgenterDTO.getInvitorUserId()));
			if(agenter != null){//邀请人是代理
				UserAgenter userAgenter = new UserAgenter();
				userAgenter.setAgenterId(agenter.getId());
				userAgenter.setUserId(loginUser.getId());
				return R.status(this.userAgenterService.saveOrUpdate(userAgenter));
			}
		}

		return R.status(true);
	}


	/**
	 * 删除
	 */
	@PostMapping("/remove")
	@ApiOperationSupport(order = 8)
	@ApiOperation(value = "删除", notes = "传入ids")
	public R remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
		return R.status(userAgenterService.removeByIds(Func.toLongList(ids)));
	}


}
